jlzzjlzz亚洲乱熟在线播放

系統城裝機大師 - 唯一官網:www.farandoo.com!

當前位置:首頁 > 腳本中心 > linux shell > 詳細頁面

Shell腳本中多命令邏輯執行順序的方法詳解

時間:2020-03-03來源:電腦系統城作者:電腦系統城

Linux中可以使用分號“;”、雙and號“&&”和雙豎線“||”來連接多個命令。單"&"符號也算命令連接符號,只不過它是將其前面的命令放入后臺執行,所以可以變相地實現命令并行執行。

1.分號";"

command1 ; command2

命令之間沒有邏輯關系。分號連接的命令會按照順序從前向后依次執行,但分號兩端的命令之間沒有任何邏輯關系,所有寫出來的命令最終都會被執行,即使分號前面的命令出錯也不影響后面的命令。


 
  1. [root@xuexi ~]# ls das;echo "hdakl"
  2. ls: cannot access das: No such file or directory
  3.  
  4. hdakl

2.&&

command1  &&  command2

邏輯與。&&連接的命令會按照順序從前向后執行,但只有當command1正確執行才執行command2,如果command1不正確執行,則不執行command2。在bash中,通過預定義變量“$?”來判斷命令是否正確執行,如果"$?"的值為0則表示前一條命令正確執行,其他任意值都表示不正確執行。\


 
  1. [root@xuexi ~]# echo "hdakl" && ls ds
  2. hdakl
  3. ls: cannot access ds: No such file or directory
  4. [root@xuexi ~]# ls das && echo "hdakl"
  5. ls: cannot access das: No such file or directory

3.||

command1 || command2

邏輯或。||連接的命令會按照順序從前向后執行,但只有當command1不正確執行才執行command2,command1正確執行則不會執行command2。||和&&都是短路符號,符號左右的命令之間具有邏輯關系。


 
  1. [root@xuexi ~]# ls das || echo "hdakl"
  2. ls: cannot access das: No such file or directory
  3. hdakl
  4. [root@xuexi ~]# echo "hdakl" || ls ds
  5. hdakl

一般要聯合使用&&和||的時候,基本上都會先邏輯與再邏輯或:command1 && command2 || command3。因為在實際中,command2和command3應該都是想要執行的命令。如果command1正確執行,$?就等于0,執行command2,再看情況執行command3,如果command1錯誤執行,$?就不等于0,所以不執行command2,根據$?為非0值,判斷了 || 右邊的命令應該被執行。

通俗點的理解方法是根據語義判斷。“如果...就...否則...就...”的語句使用“cmd1 && cmd2 || cmd3”,“如果不...就...否則...就...”使用“!cmd1 && cmd2 || cmd3”。

例如,如果用戶user1存在,就顯示用戶已經存在,否則,就添加此用戶。


 
  1. [root@xuexi tmp]# id user1 && echo "user1 exists" || useradd user1

如果用戶user2不存在,則添加此用戶,否則顯示用戶已存在。


 
  1. [root@xuexi tmp]# !id user2 && useradd user2 || echo "user2 exists"

如果用戶user3不存在,則添加此用戶,并設定其密碼為用戶名本身,否則顯示用戶已存在。


 
  1. [root@xuexi tmp]# !id user3 && useradd user3 && echo "user3" | passwd --stdin user3 ||echo "user3 exists"

4.&

command1 &
command1 & command2

&表示將其前面的命令放入后臺執行,放入后臺后會立即返回到bash環境讓用戶可以繼續和bash交互。如果&符號連接了兩個命令,則其前面的命令被放入后臺,立即執行后面的命令,所以可以簡單地認為這兩個命令是并行執行的,兩端的命令之間也沒有任何邏輯關系。

需要注意的一點是,在終端的bash環境下,子shell中的后臺的進程不受終端控制,在終端被關閉時它會掛靠在init/systemd進程下,因此退出終端或腳本shell環境,無法中斷這些后臺進程。例如:


 
  1. [root@xuexi ~]# (sleep 10 &) # 終端1上執行,立即關閉該終端
  2.  
  3. [root@xuexi ~]# ps aux | grep slee[p] # 終端2上捕捉sleep進程
  4. root 5732 0.0 0.0 107892 624 ? S 00:28 0:00 sleep 10

注意ps結果中的"?",它表示非終端進程,即脫離了終端。

知識點補充:Shell  命令執行順序

在執行某個命令的時候,有時需要依賴于前一個命令是否執行成功。例如,假設你希望將一個目錄中的文件全部拷貝到另外一個目錄中后,然后刪除源目錄中的全部文件。在刪除之前,你希望能夠確信拷貝成功,否則就有可能丟失文件

在本文中,我們將討論:

命令執行控制。

命令組合。

&&的使用:

   &&就可以解決上面背景說的問題。前面指令執行成功才執行后面的指令。

       使用語法:

 命令1&&命令2

       相當于邏輯與操作:

condition1 && condition2

只有當condition1為True,才會判斷得出condition2 

示例:

要求:拷貝 /tmp/nginx.conf 到 /etc/nginx/nginx.conf 后把/tmp/nginx.conf刪除

cp /tmp/nginx.conf /etc/nginx/nginx.conf&&rm -rf /tmp/nginx.conf

||的使用:

    ||的意思是,當||前面的命令執行成功就不執行||后面的命令

    使用語法:

命令1||命令2

邏輯或的思維。

示例:

要求:拷貝 /tmp/nginx.conf 到 /etc/nginx/nginx.conf 否則把/tmp/nginx.conf 拷貝到 /usr/nginx/nginx.conf

cp /tmp/nginx.conf /etc/nginx/nginx.conf||cp /tmp/nginx.conf /usr/nginx/nginx.conf
為了在當前s h e l l中執行一組命令,可以用命令分隔符隔開每一個命令,并把所有的命令 用圓括號()括起來。

語法:

(命令1;命令2;. . .)

示例:當失敗了,發郵件給自己然后退出


 
  1. [root@localhost shell_protest]# cat co.sh
  2. #!/bin/bash
  3. ?
  4. false||echo "it is fail"|mail nick&&exit
  5. #特例:當失敗了,發郵件也失敗了,就退出不了程序了
  6. false||echo "it is fail"|mail nick||exit
  7. #特例:當失敗了,發郵件也成功了,但退出不了程序了
  8. false||(echo "it is fail"|mail nick;exit)
  9. #所以,使用()來組合命令,是一種不錯的選擇

總結:

在編寫shell腳本時,使用&&和||對構造判斷語句非常有用。如果希望在前一個命令執行失敗的情況不執行后面的命令,那么本文所講述的方法非常簡單有效。使用這樣的方法,可以根據&&或||前面命令的返回值來控制其后面命令的執行。

到此這篇關于Shell腳本中多命令邏輯執行順序的方法詳解的文章就介紹到這了,更多相關shell腳本多命令執行順序內容請搜索我們以前的文章或繼續瀏覽下面的相關文章希望大家以后多多支持我們!

分享到:

相關信息

系統教程欄目

欄目熱門教程

人氣教程排行

站長推薦

熱門系統下載